//Revisions number
#define SWHIGH  0
#define SWLOW   6
// mt
#define SWLOWLOW 5

// main.h

void Initialization(void);
unsigned char StateMachine(char state, unsigned char stimuli);
char BootFunc(char input);
char PowerSaveFunc(char input);
char AutoPower(char input);
char KeyClick(char input);
void Delay(unsigned long millisec);
char Revision(char input);
void OSCCAL_calibration(void);
void SaveConfig(void);
void BlinkingCharacter(int PlaceNumber, char character);
void DispString(unsigned char character0, unsigned char character1, unsigned char character2, unsigned char character3, unsigned char character4, unsigned char character5);

extern int gLEDtimer;

#define BOOL    char

#define FALSE   0
#define TRUE    (!FALSE)
#define NULL    0

#define AUTO    3


// Macro definitions
//mtA - 
// sbi and cbi will not be supported by future avr-libc
// version - changed to sbiBF/cbiBF "everywhere"
#define sbiBF(port,bit)  (port |= (1<<bit))   //set bit in port
#define cbiBF(port,bit)  (port &= ~(1<<bit))  //clear bit in port
//mtE

// Menu state machine states
#define ST_DEFAULT					00
#define ST_AUTO						10
#define ST_DRI						20
#define ST_LIGHT					30
#define ST_MAN						40
#define ST_SET						100
#define ST_OPTION					200

#define ST_AUTO_START				11
#define ST_AUTO_RUN_SHOOT			12
#define ST_AUTO_RUN_WAIT			13

#define ST_DRI_RUN					21		//TK: for DRI functionality
#define ST_DRI_STOP					22		//TK: for DRI functionality  // evtl. nicht gebraucht!!

#define ST_LIGHT_RUN				31		//FJB: for Light-Automatic-Shoot

#define ST_MAN_START				41
#define ST_MAN_STOP					42


#define ST_SHOOT_TIME				110
#define ST_SHOOT_TIME_SET_SEC_1		111		//TK: added state to improve handling
#define ST_SHOOT_TIME_SET_SEC_10	112		//TK: added state to improve handling
#define ST_SHOOT_TIME_SET_MIN_1		113		//TK: added state to improve handling
#define ST_SHOOT_TIME_SET_MIN_10	114		//TK: added state to improve handling
#define ST_WAIT_TIME				120
#define ST_WAIT_TIME_SET_SEC_1		121		//TK: added state to improve handling
#define ST_WAIT_TIME_SET_SEC_10		122		//TK: added state to improve handling
#define ST_WAIT_TIME_SET_MIN_1		123		//TK: added state to improve handling
#define ST_WAIT_TIME_SET_MIN_10		124		//TK: added state to improve handling
#define ST_SHOOT_COUNT				130
#define ST_SHOOT_COUNT_SET_1		131		//TK: added state to improve handling
#define ST_SHOOT_COUNT_SET_10		132		//TK: added state to improve handling
#define ST_SHOOT_COUNT_SET_100		133		//TK: added state to improve handling
#define ST_SHOOT_COUNT_SET_1000		134		//TK: added state to improve handling
#define ST_DRI_SET_MIN				140		//TK: for DRI functionality
#define ST_DRI_SHUTTER_MIN			141		//TK: for DRI functionality
#define ST_DRI_SET_MAX				142		//TK: for DRI functionality	
#define ST_DRI_SHUTTER_MAX			143		//TK: for DRI functionality		
#define ST_DRI_SET_STEP				144		//FJB: for DRI Shutterstep F-full or F-1/3
#define ST_DRI_SHUTTER_STEP			145		//FJB: for DRI Shutterstep F-full or F-1/3

#define ST_MIRROR_TIME				150		//FJB: for Time to lock the Mirror
#define ST_MIRROR_TIME_SET			151		//FJB: for Time to lock the Mirror
#define ST_CAMERA_WAIT				152		//FJB: for Time to wait for Camera (AF)
#define ST_CAMERA_WAIT_SET			153		//FJB: for Time to wait for Camera (AF)

#define ST_OPTION_BUZZER			201
#define ST_OPTION_BUZZER_SET		202
#define ST_OPTION_CLICK				203
#define ST_OPTION_CLICK_SET			204
#define ST_OPTION_LED				205
#define ST_OPTION_LED_SET			206
#define ST_OPTION_TEMP				207
#define ST_OPTION_TEMP_SHOW			208

#define LED_STATE_OFF				0
#define LED_STATE_ON				1
#define LED_STATE_LIGHT				2
#define LED_STATE_AUTO				3

//Button definitions

#define KEY_NULL    0
#define KEY_ENTER   1
#define KEY_NEXT    2
#define KEY_PREV    3
#define KEY_PLUS    4
#define KEY_MINUS   5
